<?php
//register and enqueue styles
function wcf2w_style() {
	wp_enqueue_style('wcf2w-fonts', '//fonts.googleapis.com/css?family=Montserrat:400,600,800|Open+Sans:400,300,600');

	wp_register_style('wcf2w-socicon', plugins_url('assets/css/socicon.css', __FILE__), false, false, 'all');
	wp_enqueue_style('wcf2w-socicon');

	wp_register_style('wcf2w-style', plugins_url('assets/css/style.css', __FILE__), false, false, 'all');
	wp_enqueue_style('wcf2w-style');

	wp_register_style('wcf2w-animate', plugins_url('assets/css/ak86_animate.css', __FILE__), false, false, 'all');
	wp_enqueue_style('wcf2w-animate');
}

//register and enqueue scripts
function wcf2w_scripts() {
	wp_register_script('wcf2w-modal', plugins_url('assets/js/modal.js', __FILE__));
	wp_enqueue_script('wcf2w-modal');

	wp_register_script('wcf2w-script', plugins_url('assets/js/script.js', __FILE__));
	wp_enqueue_script('wcf2w-script');
	
} 

//enqueue script in widget's page
function wcf2w_admin_scripts($admin_page){

	$wcf2w_post_type = get_post_type();
	if($wcf2w_post_type == 'wcf2w_contacts'){
		wp_register_script('wcf2w_admin_script', plugins_url('assets/js/admin-script.js', __FILE__));
		wp_enqueue_script('wcf2w_admin_script');	
	}

	if('widgets.php' == $admin_page){
		wp_enqueue_script('wp-color-picker');
		wp_enqueue_style('wp-color-picker');
		wp_register_script('wcf2w_widget_script', plugins_url('assets/js/widget-script.js', __FILE__));
		wp_enqueue_script('wcf2w_widget_script');
	}
}

//enqueue script in admin page
function wcf2w_admin_style(){
	$wcf2w_post_type = get_post_type();
	if($wcf2w_post_type == 'wcf2w_contacts'){
		wp_register_style('wcf2w_admin_style', plugins_url('assets/css/admin-style.css', __FILE__));
		wp_enqueue_style('wcf2w_admin_style');	
	}
}

add_action('wp_head','wcf2w_scripts');
add_action('wp_enqueue_scripts', 'wcf2w_style');
add_action('admin_enqueue_scripts', 'wcf2w_admin_scripts');
add_action('admin_enqueue_scripts', 'wcf2w_admin_style');
?>