<?php

/*Main functions*/

//languages textdomain settings
add_action('plugins_loaded','wcf2w_languages');
function wcf2w_languages() {
	load_plugin_textdomain('wcf2w', false, dirname( plugin_basename( __FILE__ ) ).'/languages/');
}

//only numbers
function wcf2w_only_numbers($number) { 
	return preg_replace('/[^0-9]/', '', $number);
}

//get animation class
function wcf2w_get_animation_class($wcf2w_animation_button) { 
	$wcf2w_animation_button = strtolower($wcf2w_animation_button);
	if($wcf2w_animation_button == 'none'){$animation_class = ' ';}   
    if($wcf2w_animation_button == 'rotate'){$animation_class = 'ak86_rotate';}             	
    if($wcf2w_animation_button == 'tada'){$animation_class = 'ak86_tada';}   
    if($wcf2w_animation_button == 'swing'){$animation_class = 'ak86_swing';}   
    if($wcf2w_animation_button == 'grow'){$animation_class = 'ak86_grow';} 
    if($wcf2w_animation_button == 'shrink'){$animation_class = 'ak86_shrink';}
    if($wcf2w_animation_button == 'buzz'){$animation_class = 'ak86_buzz';} 
    if($wcf2w_animation_button == 'forward'){$animation_class = 'ak86_forward';}
    if($wcf2w_animation_button == 'backward'){$animation_class = 'ak86_backward';} 

	return $animation_class;
}

//check mobile device functions
function wcf2w_check_mobile_device() { 
  $useragent = $_SERVER['HTTP_USER_AGENT'];
	if(
		preg_match(
			'/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i',
			$useragent
		)
		||
		preg_match(
			'/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i',
			substr($useragent,0,4)
		)
	)
		return true;
	return false;   
}

add_filter('widget_text', 'do_shortcode');

//getting thumbnail
function wcf2w_get_thumbnail($spID, $size){
	$id_img = get_post_thumbnail_id($spID);
	$image = wp_get_attachment_image_src($id_img, $size);

	if($image[0] == '') $result = plugins_url('wcf2w/assets/imgs/user.svg');
	else $result = esc_url($image[0]);
	
	return $result;
}

//getting availability day and time
function wcf2w_get_days($id){
	$wcf2w_days = array();

	$wcf2w_monday = get_post_meta($id, 'wcf2w_monday', true);
	$wcf2w_tuesday = get_post_meta($id, 'wcf2w_tuesday', true);
	$wcf2w_wednesday = get_post_meta($id, 'wcf2w_wednesday', true);
	$wcf2w_thursday = get_post_meta($id, 'wcf2w_thursday', true);
	$wcf2w_friday = get_post_meta($id, 'wcf2w_friday', true);
	$wcf2w_saturday = get_post_meta($id, 'wcf2w_saturday', true);
	$wcf2w_sunday = get_post_meta($id, 'wcf2w_sunday', true);

    $wcf2w_monday_from = get_post_meta($id, 'wcf2w_monday_from', true);
    $wcf2w_monday_to = get_post_meta($id, 'wcf2w_monday_to', true);
    $wcf2w_tuesday_from = get_post_meta($id, 'wcf2w_tuesday_from', true);
    $wcf2w_tuesday_to = get_post_meta($id, 'wcf2w_tuesday_to', true);
    $wcf2w_wednesday_from = get_post_meta($id, 'wcf2w_wednesday_from', true);
    $wcf2w_wednesday_to = get_post_meta($id, 'wcf2w_wednesday_to', true);
    $wcf2w_thursday_from = get_post_meta($id, 'wcf2w_thursday_from', true);
    $wcf2w_thursday_to = get_post_meta($id, 'wcf2w_thursday_to', true);
    $wcf2w_friday_from = get_post_meta($id, 'wcf2w_friday_from', true);
    $wcf2w_friday_to = get_post_meta($id, 'wcf2w_friday_to', true);
    $wcf2w_saturday_from = get_post_meta($id, 'wcf2w_saturday_from', true);
    $wcf2w_saturday_to = get_post_meta($id, 'wcf2w_saturday_to', true);
    $wcf2w_sunday_from = get_post_meta($id, 'wcf2w_sunday_from', true);
    $wcf2w_sunday_to = get_post_meta($id, 'wcf2w_sunday_to', true);

	if($wcf2w_monday == 'y') $wcf2w_days[1]['Day'] = '1';
    if($wcf2w_monday == 'y') $wcf2w_days[1]['From'] = $wcf2w_monday_from;
    if($wcf2w_monday == 'y') $wcf2w_days[1]['To'] = $wcf2w_monday_to;
    
	if($wcf2w_tuesday == 'y') $wcf2w_days[2]['Day'] = '2';
	if($wcf2w_tuesday == 'y') $wcf2w_days[2]['From'] = $wcf2w_tuesday_from;
	if($wcf2w_tuesday == 'y') $wcf2w_days[2]['To'] = $wcf2w_tuesday_to;

	if($wcf2w_wednesday == 'y') $wcf2w_days[3]['Day'] = '3';
	if($wcf2w_wednesday == 'y') $wcf2w_days[3]['From'] = $wcf2w_wednesday_from;
	if($wcf2w_wednesday == 'y') $wcf2w_days[3]['To'] = $wcf2w_wednesday_to;

	if($wcf2w_thursday == 'y') $wcf2w_days[4]['Day'] = '4';
	if($wcf2w_thursday == 'y') $wcf2w_days[4]['From'] = $wcf2w_thursday_from;
	if($wcf2w_thursday == 'y') $wcf2w_days[4]['To'] = $wcf2w_thursday_to;

	if($wcf2w_friday == 'y') $wcf2w_days[5]['Day'] = '5';
	if($wcf2w_friday == 'y') $wcf2w_days[5]['From'] = $wcf2w_friday_from;
	if($wcf2w_friday == 'y') $wcf2w_days[5]['To'] = $wcf2w_friday_to;

	if($wcf2w_saturday == 'y') $wcf2w_days[6]['Day'] = '6';
	if($wcf2w_saturday == 'y') $wcf2w_days[6]['From'] = $wcf2w_saturday_from;
	if($wcf2w_saturday == 'y') $wcf2w_days[6]['To'] = $wcf2w_saturday_to;

	if($wcf2w_sunday == 'y') $wcf2w_days[7]['Day'] = '0';
	if($wcf2w_sunday == 'y') $wcf2w_days[7]['From'] = $wcf2w_sunday_from;
	if($wcf2w_sunday == 'y') $wcf2w_days[7]['To'] = $wcf2w_sunday_to;

	return $wcf2w_days;
}

//get contact list
function wcf2w_get_contact_list($type = null, $id = null){

	if($type == 'single_page'){
		$wcf2w_class = 'wcf2w_single_page';
	} else {
		$wcf2w_class = '';
	}

	$result = '';
	$result .= '<div class="wcf2w_list '.$wcf2w_class.'">';
    
	$args = array(
        'numberposts' => -1,
        'orderby'     => 'date',
        'order'       => 'DESC',
        'post_type'   => 'wcf2w_contacts',
        'post_status' => 'publish',
    );

	if($type == 'single_page'){
		$args['meta_query'][] = array(
			array(
				'key'     => 'wcf2w_add_to_product_page',
				'value'   => 'yes',
				'compare' => '=',
			)
		);
	}	

	if(!empty($id)){
		$args['include'] = $id;
	}

    $posts = get_posts($args);
    
    foreach($posts as $post){ 
    	setup_postdata($post); 

    	$wcf2w_current_day = date('w');
    	$wcf2w_current_time = current_time('H:i');
    	$wcf2w_days = wcf2w_get_days($post->ID);

        $wcf2w_status_class = 'wcf2w_offline';
        $wcf2w_status_text = 'offline';
       

    	foreach ($wcf2w_days as $wcf2w_day) {
    		if($wcf2w_day['Day'] == $wcf2w_current_day){
    			$wcf2w_time_from = $wcf2w_day['From'];
    			$wcf2w_time_to = $wcf2w_day['To'];
    			if(strtotime($wcf2w_current_time) >= strtotime($wcf2w_time_from) && strtotime($wcf2w_current_time) <= strtotime($wcf2w_time_to)){
    					$wcf2w_status_class = 'wcf2w_online';
                        $wcf2w_status_text = 'online';
                        break;
    			}
    		}
    	}

    	$wcf2w_exclude_from_list = get_post_meta($post->ID, 'wcf2w_exclude_from_list', true);

    	if($type == 'single_page') $wcf2w_exclude_from_list = 'no';

    	if($wcf2w_exclude_from_list != 'yes'){
	    	$wcf2w_thumbnail = wcf2w_get_thumbnail($post->ID, 'medium');
	    	$wcf2w_contact_name = get_the_title($post->ID);
	    	$wcf2w_contact_title = get_post_meta($post->ID, 'wcf2w_title', true);
	    	$wcf2w_contact_phone = get_post_meta($post->ID, 'wcf2w_phone', true);
			$wcf2w_contact_msg = get_post_meta($post->ID, 'wcf2w_msg', true);

		    //item wrapper
		    $result .= '<div class="wcf2w_item '.$wcf2w_status_class.'" data-phone="'.$wcf2w_contact_phone.'" data-msg="'.$wcf2w_contact_msg.'" id="wcf2w_item_'.$post->ID.'">';
		    
		    //thumbnail
		    $result .= '<div class="wcf2w_thumbnail">';
		    $result .= '<img src="'.$wcf2w_thumbnail.'" alt="'.$wcf2w_contact_name.'">';
		    $result .= '</div>';

		    //contact info
		    $result .= '<div class="wcf2w_contact_info">';
		    $result .= '<p class="wcf2w_contact_name">'.$wcf2w_contact_name.'</p>';
		    $result .= '<p class="wcf2w_contact_title">'.$wcf2w_contact_title.'</p>';
		    $result .= '<p class="wcf2w_contact_status">'.$wcf2w_status_text.'</p>';
		    $result .= '</div>';

		    //icon
		    $result .= '<div class="wcf2w_icon">';
		    $result .= '<i class="socicon-whatsapp"></i>';
			$result .= '</div>';
		    
		    //end item wrapper
		    $result .= '</div>';
		}    
	}    

	wp_reset_postdata();

    $result .= '</div>';
    return $result;
}

//get modal
function wcf2w_modal(){

	$wcf2w_header_title = get_theme_mod('wcf2w_header_title');
	$wcf2w_header_subtitle = get_theme_mod('wcf2w_header_subtitle');

	if(empty($wcf2w_header_title)) $wcf2w_header_title = 'Start a Conversation';
	if(empty($wcf2w_header_subtitle)) $wcf2w_header_subtitle = 'Hi! Click one of our member below to chat on Whatsapp';

    echo '<div data-modal-cover="disabled" id="wcf2w_open" class="cross_remove">';    
    echo '<div data-modal-dialog class="cross_add wcf2w_cover">';
    echo '<span data-modal-inner-close></span>';
    echo '<div class="wcf2w_modal_heading">';
    echo '<p class="wcf2w_modal_title">'.esc_html($wcf2w_header_title).'</p>';
    echo '<p class="wcf2w_modal_subtitle">'.esc_html($wcf2w_header_subtitle).'<p>';
    echo '</div>';
    echo '<div class="wcf2w_result">';
   	echo wcf2w_get_contact_list();
    echo '</div>';
    echo '</div>';
    echo '</div>';

}
add_action('wp_footer', 'wcf2w_modal');

//customizer
function wcf2w_customize_register($wp_customize) {

    $wp_customize->add_section('wcf2w_settings' , array(
        'title'    => __('WhatsApp Contact Button', 'wcf2w'),
        'priority' => 1
    ));
    
    //Header bg color
    $wp_customize->add_setting('wcf2w_header_bg_color', array(
        'default'   => '#2db742',
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_hex_color',
    ));

    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'wcf2w_header_bg_color', array(
        'section' => 'wcf2w_settings',
        'label'   => __('Header bg color', 'wcf2w'),
    )));

    //Header title color
    $wp_customize->add_setting('wcf2w_header_text_color', array(
        'default'   => '#ffffff',
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_hex_color',
    ));

    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'wcf2w_header_text_color', array(
        'section' => 'wcf2w_settings',
        'label'   => __('Header text color', 'wcf2w'),
    )));

    //Header title
    $wp_customize->add_setting('wcf2w_header_title', array(
  		'capability' => 'edit_theme_options',
  		'default' => 'Start a Conversation',
  		'sanitize_callback' => 'sanitize_text_field',
	));

	$wp_customize->add_control('wcf2w_header_title', array(
  	  'type' => 'input',
  	  'section' => 'wcf2w_settings',
  	  'label' => __('Header title', 'wcf2w'),
	));

	//Header subtitle
    $wp_customize->add_setting('wcf2w_header_subtitle', array(
  		'capability' => 'edit_theme_options',
  		'default' => 'Hi! Click one of our member below to chat on Whatsapp',
  		'sanitize_callback' => 'sanitize_text_field',
	));

	$wp_customize->add_control('wcf2w_header_subtitle', array(
  	  'type' => 'input',
  	  'section' => 'wcf2w_settings',
  	  'label' => __('Header subtitle', 'wcf2w'),
	));

	//Content bg color
    $wp_customize->add_setting('wcf2w_content_bg_color', array(
        'default'   => '#ffffff',
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_hex_color',
    ));

    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'wcf2w_content_bg_color', array(
        'section' => 'wcf2w_settings',
        'label'   => __('Content bg color', 'wcf2w'),
    )));

    //Item font color 1
    $wp_customize->add_setting('wcf2w_item_font_color_1', array(
        'default'   => '#353535',
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_hex_color',
    ));

    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'wcf2w_item_font_color_1', array(
        'section' => 'wcf2w_settings',
        'label'   => __('Item font color 1', 'wcf2w'),
    )));

    //Item font color 2
    $wp_customize->add_setting('wcf2w_item_font_color_2', array(
        'default'   => '#909090',
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_hex_color',
    ));

    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'wcf2w_item_font_color_2', array(
        'section' => 'wcf2w_settings',
        'label'   => __('Item font color 2', 'wcf2w'),
    )));

    //Item bg color
    $wp_customize->add_setting('wcf2w_item_bg_color', array(
        'default'   => '#fff',
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_hex_color',
    ));

    $wp_customize->add_control( new WP_Customize_Color_Control($wp_customize, 'wcf2w_item_bg_color', array(
        'section' => 'wcf2w_settings',
        'label'   => __('Item bg color', 'wcf2w'),
    )));

}
add_action('customize_register', 'wcf2w_customize_register');

//get styling
function wcf2w_styling(){
	$wcf2w_header_bg_color = get_theme_mod('wcf2w_header_bg_color');
	$wcf2w_header_text_color = get_theme_mod('wcf2w_header_text_color');
	$wcf2w_content_bg_color = get_theme_mod('wcf2w_content_bg_color');
	$wcf2w_item_font_color_1 = get_theme_mod('wcf2w_item_font_color_1');
	$wcf2w_item_font_color_2 = get_theme_mod('wcf2w_item_font_color_2');
	$wcf2w_item_bg_color = get_theme_mod('wcf2w_item_bg_color');

	if(empty($wcf2w_header_bg_color)) $wcf2w_header_bg_color = '#2db742';
	if(empty($wcf2w_header_text_color)) $wcf2w_header_text_color = '#ffffff';
	if(empty($wcf2w_content_bg_color)) $wcf2w_content_bg_color = '#ffffff';
	if(empty($wcf2w_item_font_color_1)) $wcf2w_item_font_color_1 = '#353535';
	if(empty($wcf2w_item_font_color_2)) $wcf2w_item_font_color_2 = '#909090';
	if(empty($wcf2w_item_bg_color)) $wcf2w_item_bg_color = '#ffffff';

	$result = '<style>';
    $result .= '.wcf2w_modal_heading {background: '.$wcf2w_header_bg_color.'}';
    $result .= '.wcf2w_modal_heading p {color: '.$wcf2w_header_text_color.'}';
    $result .= '.wcf2w_result {background: '.$wcf2w_content_bg_color.'}';
    $result .= '.wcf2w_item {background: '.$wcf2w_item_bg_color.'}';
    $result .= '.wcf2w_contact_name {color: '.$wcf2w_item_font_color_1.'}';
    $result .= '.wcf2w_contact_title {color: '.$wcf2w_item_font_color_2.'}';
    $result .= '.wcf2w_icon i {color: '.$wcf2w_header_bg_color.'}';
    $result .= '.wcf2w_item {border-left: 2px solid '.$wcf2w_header_bg_color.'}';
    $result .= '</style>';

    echo $result;

}

add_action('wp_footer', 'wcf2w_styling');

/*WooCommerce*/

include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
if ( is_plugin_active( 'woocommerce/woocommerce.php' ) ) {

    //Add button to woocommerce 
    function wcf2w_add_content_after_addtocart_button() {
    	echo wcf2w_get_contact_list('single_page', '');
    }

    add_action('woocommerce_after_add_to_cart_button', 'wcf2w_add_content_after_addtocart_button');

}    

/*Shortcode*/

//whatsapp_contact shordcode
add_shortcode('whatsapp_contact', 'wcf2w_shortcode');
function wcf2w_shortcode($atts, $content = null) {

	extract( shortcode_atts(array(
        "id" => '',
    ), $atts ) );

    if(!empty($id)){
    	return wcf2w_get_contact_list('single_page', $id);
    }

}
?>