<?php
//register wcf2w_contacts post type
function wcf2w_register_post_type() {
	$labels = array(
		"name" => __('WhatsApp CB', 'wcf2w'),
		"singular_name" => __('WhatsApp CB', 'wcf2w'),
		"all_items" => __('All Accounts', 'wcf2w'),
		"add_new" => __('Add New Account', 'wcf2w'),
		"add_new_item" => __('Add New Account', 'wcf2w'),
		"edit_item" => __('Edit Account', 'wcf2w'),
		"new_item" => __('New Account', 'wcf2w'),
		"view_item" => __('View Account', 'wcf2w'),
		"view_items" => __('View Accounts', 'wcf2w'),
		"search_items" => __('Search Account', 'wcf2w'),
		"not_found" => __('Not_found', 'wcf2w'),
		"not_found_in_trash" => __('Not_found in trash', 'wcf2w'),
	);
	$args = array(
		"label" => __('WhatsApp CB', 'wcf2w'),
		"labels" => $labels,
		"description" => "",
		"public" => true,
		"publicly_queryable" => true,
		"show_ui" => true,
		"show_in_rest" => false,
		"rest_base" => "",
		"has_archive" => false,
		"show_in_menu" => true,
		"exclude_from_search" => false,
		"capability_type" => "post",
		"map_meta_cap" => true,
		"hierarchical" => true,
		"rewrite" => array("slug" => ""),
		"query_var" => true,
		"supports" => array("title", "thumbnail"),
		"menu_icon" => plugins_url('wcf2w/assets/imgs/wcf2w.png'),
	);
	register_post_type("wcf2w_contacts", $args);
}
add_action('init', 'wcf2w_register_post_type');

//add meta boxes
add_action('add_meta_boxes', 'wcf2w_add_meta_box');
function wcf2w_add_meta_box() {
    add_meta_box('wcf2w_meta_box', __('Settings', 'wcf2w'), 'wcf2w_fields_form_show', 'wcf2w_contacts', 'normal', 'default');
}

//setting page
function wcf2w_fields_form_show($post){
    $id = $post->ID; 
    $wcf2w_phone = get_post_meta($id, 'wcf2w_phone', true);
    $wcf2w_title = get_post_meta($id, 'wcf2w_title', true);
	$wcf2w_msg = get_post_meta($id, 'wcf2w_msg', true);
	$wcf2w_add_to_product_page = get_post_meta($id, 'wcf2w_add_to_product_page', true);
	$wcf2w_exclude_from_list = get_post_meta($id, 'wcf2w_exclude_from_list', true);

    if(empty($wcf2w_phone)) $wcf2w_phone = '';
    if(empty($wcf2w_title)) $wcf2w_title = '';
    if(empty($wcf2w_msg)) $wcf2w_msg = '';
    ?>

    <p><label for="wcf2w_phone"><?php echo __('Phone', 'wcf2w')?>:</label></br>
    + <input type="number" name="wcf2w_phone" id="wcf2w_phone" value="<?php echo $wcf2w_phone;?>" required style="width:97%;"></p>
    <p><i><?php echo __('Use mobile phone number without "+" character. Example: 79094459070.', 'wcf2w'); ?></i></p>

    <p><label for="wcf2w_title"><?php echo __('Title', 'wcf2w')?>:</label></br>
    <input type="text" name="wcf2w_title" id="wcf2w_title" value="<?php echo $wcf2w_title;?>" required style="width:100%;"></p>
    
    <p><label for="wcf2w_msg"><?php echo __('Message', 'wcf2w')?>:</label></br>
    <textarea name="wcf2w_msg" id="wcf2w_msg" style="width:100%; height: 150px"><?php echo $wcf2w_msg;?></textarea></p>

    <p><label for="wcf2w_exclude_from_list"><?php echo __('Exclude from list', 'wcf2w')?>:</label></br>
    <select name="wcf2w_exclude_from_list" id="wcf2w_exclude_from_list" class="wcf2w_exclude_from_list">
        <?php
        if(!empty($wcf2w_exclude_from_list)){
            echo '<option value="'.$wcf2w_exclude_from_list.'">'.$wcf2w_exclude_from_list.'</option>';
            echo '<option disabled>-------</option>';
        }
        ?>    
        <option value="no">no</option>
        <option value="yes">yes</option>
    </select>
    </p>
    <p><label for="wcf2w_add_to_product_page"><?php echo __('Add to product page(for WooCommerce)', 'wcf2w')?>:</label></br>
    <select name="wcf2w_add_to_product_page" id="wcf2w_add_to_product_page" class="wcf2w_add_to_product_page">
        <?php
        if(!empty($wcf2w_add_to_product_page)){
            echo '<option value="'.$wcf2w_add_to_product_page.'">'.$wcf2w_add_to_product_page.'</option>';
            echo '<option disabled>-------</option>';
        }
        ?>    
        <option value="no">no</option>
        <option value="yes">yes</option>
    </select>
    </p>
    
	<table class="wcf2w_table">
		<tr>
			<td colspan="4">
				<p><?php echo __('Time availability', 'wcf2w')?>:</p>
			</td>
		</tr>
		<tr>
	        <?php 
        	$wcf2w_monday = get_post_meta($id, 'wcf2w_monday', true);
        	$wcf2w_monday_from = get_post_meta($id, 'wcf2w_monday_from', true);
        	$wcf2w_monday_to = get_post_meta($id, 'wcf2w_monday_to', true);

        	if(empty($wcf2w_monday_from)) $wcf2w_monday_from = '00:00';
        	if(empty($wcf2w_monday_to)) $wcf2w_monday_to = '23:59';

	        ?>
	        <td>
	        	<input type="checkbox" name="wcf2w_monday" id="wcf2w_monday" value="<?php echo $wcf2w_monday?>" <?php if($wcf2w_monday == 'y') echo "checked"; ?>>
	        </td>
	        <td>
	        	<p><?php echo __('Monday', 'wcf2w')?></p>
	        </td>
	        <td>
	        	<input type="time" name="wcf2w_monday_from" id="wcf2w_monday_from" value="<?php echo $wcf2w_monday_from?>"  style="width:100%;">
	        </td> 
	        <td>
	        	<input type="time" name="wcf2w_monday_to" id="wcf2w_monday_to" value="<?php echo $wcf2w_monday_to?>"  style="width:100%;">
	        </td> 
	    </tr>
	    <tr>
	        <?php 
	        $wcf2w_tuesday = get_post_meta($id, 'wcf2w_tuesday', true);
	        $wcf2w_tuesday_from = get_post_meta($id, 'wcf2w_tuesday_from', true);
	        $wcf2w_tuesday_to = get_post_meta($id, 'wcf2w_tuesday_to', true);

	        if(empty($wcf2w_tuesday_from)) $wcf2w_tuesday_from = '00:00';
        	if(empty($wcf2w_tuesday_to)) $wcf2w_tuesday_to = '23:59';
	        ?>
	        <td>
	        	<input type="checkbox" name="wcf2w_tuesday" id="wcf2w_tuesday" value="<?php echo $wcf2w_tuesday?>" <?php if($wcf2w_tuesday == 'y') echo "checked"; ?>>
	        </td>
	        <td>
	        	<p><?php echo __('Tuesday', 'wcf2w')?></p>
	        </td>
	        <td>
	        	<input type="time" name="wcf2w_tuesday_from" id="wcf2w_tuesday_from" value="<?php echo $wcf2w_tuesday_from?>"  style="width:100%;">
	        </td> 
	        <td>
	        	<input type="time" name="wcf2w_tuesday_to" id="wcf2w_tuesday_to" value="<?php echo $wcf2w_tuesday_to?>"  style="width:100%;">
	        </td> 
	    </tr>
	    <tr>
	        <?php 
	        $wcf2w_wednesday = get_post_meta($id, 'wcf2w_wednesday', true);
	        $wcf2w_wednesday_from = get_post_meta($id, 'wcf2w_wednesday_from', true);
	        $wcf2w_wednesday_to = get_post_meta($id, 'wcf2w_wednesday_to', true);

	        if(empty($wcf2w_wednesday_from)) $wcf2w_wednesday_from = '00:00';
        	if(empty($wcf2w_wednesday_to)) $wcf2w_wednesday_to = '23:59';
	        ?>
	        <td>
	        	<input type="checkbox" name="wcf2w_wednesday" id="wcf2w_wednesday" value="<?php echo $wcf2w_wednesday?>" <?php if($wcf2w_wednesday == 'y') echo "checked"; ?>>
	        </td>
	        <td>
	        	<p><?php echo __('Wednesday', 'wcf2w')?></p>
	        </td>
	        <td>
	        	<input type="time" name="wcf2w_wednesday_from" id="wcf2w_wednesday_from" value="<?php echo $wcf2w_wednesday_from?>"  style="width:100%;">
	        </td> 
	        <td>
	        	<input type="time" name="wcf2w_wednesday_to" id="wcf2w_wednesday_to" value="<?php echo $wcf2w_wednesday_to?>"  style="width:100%;">
	        </td> 
	    </tr>
	    <tr>
	        <?php 
	        $wcf2w_thursday = get_post_meta($id, 'wcf2w_thursday', true);
	        $wcf2w_thursday_from = get_post_meta($id, 'wcf2w_thursday_from', true);
	        $wcf2w_thursday_to = get_post_meta($id, 'wcf2w_thursday_to', true);

	        if(empty($wcf2w_thursday_from)) $wcf2w_thursday_from = '00:00';
        	if(empty($wcf2w_thursday_to)) $wcf2w_thursday_to = '23:59';
	        ?>
	        <td>
	        	<input type="checkbox" name="wcf2w_thursday" id="wcf2w_thursday" value="<?php echo $wcf2w_thursday?>" <?php if($wcf2w_thursday == 'y') echo "checked"; ?>>
	        </td>
	        <td>
	        	<p><?php echo __('Thursday', 'wcf2w')?></p>
	        </td>
	        <td>
	        	<input type="time" name="wcf2w_thursday_from" id="wcf2w_thursday_from" value="<?php echo $wcf2w_thursday_from?>"  style="width:100%;">
	        </td> 
	        <td>
	        	<input type="time" name="wcf2w_thursday_to" id="wcf2w_thursday_to" value="<?php echo $wcf2w_thursday_to?>"  style="width:100%;">
	        </td> 
	    </tr>
	    <tr>
	        <?php 
	        $wcf2w_friday = get_post_meta($id, 'wcf2w_friday', true);
	        $wcf2w_friday_from = get_post_meta($id, 'wcf2w_friday_from', true);
	        $wcf2w_friday_to = get_post_meta($id, 'wcf2w_friday_to', true);

	        if(empty($wcf2w_friday_from)) $wcf2w_friday_from = '00:00';
        	if(empty($wcf2w_friday_to)) $wcf2w_friday_to = '23:59';
	        ?>
	        <td>
	        	<input type="checkbox" name="wcf2w_friday" id="wcf2w_friday" value="<?php echo $wcf2w_friday?>" <?php if($wcf2w_friday == 'y') echo "checked"; ?>>
	        </td>
	        <td>
	        	<p><?php echo __('Friday', 'wcf2w')?></p>
	        </td>
	        <td>
	        	<input type="time" name="wcf2w_friday_from" id="wcf2w_friday_from" value="<?php echo $wcf2w_friday_from?>"  style="width:100%;">
	        </td> 
	        <td>
	        	<input type="time" name="wcf2w_friday_to" id="wcf2w_friday_to" value="<?php echo $wcf2w_friday_to?>"  style="width:100%;">
	        </td> 
	    </tr>
	    <tr>
	        <?php 
	        $wcf2w_saturday = get_post_meta($id, 'wcf2w_saturday', true);
	        $wcf2w_saturday_from = get_post_meta($id, 'wcf2w_saturday_from', true);
	        $wcf2w_saturday_to = get_post_meta($id, 'wcf2w_saturday_to', true);

	        if(empty($wcf2w_saturday_from)) $wcf2w_saturday_from = '00:00';
        	if(empty($wcf2w_saturday_to)) $wcf2w_saturday_to = '23:59';
	        ?>
	        <td>
	        	<input type="checkbox" name="wcf2w_saturday" id="wcf2w_saturday" value="<?php echo $wcf2w_saturday?>" <?php if($wcf2w_saturday == 'y') echo "checked"; ?>>
	        </td>
	        <td>
	        	<p><?php echo __('Saturday', 'wcf2w')?></p>
	        </td>
	        <td>
	        	<input type="time" name="wcf2w_saturday_from" id="wcf2w_saturday_from" value="<?php echo $wcf2w_saturday_from?>"  style="width:100%;">
	        </td> 
	        <td>
	        	<input type="time" name="wcf2w_saturday_to" id="wcf2w_saturday_to" value="<?php echo $wcf2w_saturday_to?>"  style="width:100%;">
	        </td> 
	    </tr>
	    <tr>
	        <?php 
	        $wcf2w_sunday = get_post_meta($id, 'wcf2w_sunday', true);
	        $wcf2w_sunday_from = get_post_meta($id, 'wcf2w_sunday_from', true);
	        $wcf2w_sunday_to = get_post_meta($id, 'wcf2w_sunday_to', true);

	        if(empty($wcf2w_sunday_from)) $wcf2w_sunday_from = '00:00';
        	if(empty($wcf2w_sunday_to)) $wcf2w_sunday_to = '23:59';
	        ?>
	        <td>
	        	<input type="checkbox" name="wcf2w_sunday" id="wcf2w_sunday" value="<?php echo $wcf2w_sunday?>" <?php if($wcf2w_sunday == 'y') echo "checked"; ?>>
	        </td>
	        <td>
	        	<p><?php echo __('Sunday', 'wcf2w')?></p>
	        </td>
	        <td>
	        	<input type="time" name="wcf2w_sunday_from" id="wcf2w_sunday_from" value="<?php echo $wcf2w_sunday_from?>"  style="width:100%;">
	        </td> 
	        <td>
	        	<input type="time" name="wcf2w_sunday_to" id="wcf2w_sunday_to" value="<?php echo $wcf2w_sunday_to?>"  style="width:100%;">
	        </td> 
	    </tr>
	</table>    

    <p class="wcf2w_shortcode"><?php echo __('Shortcode', 'wcf2w')?>: [whatsapp_contact id=<?php echo $id?>]</p>

    <?php
}

//save data
add_action('save_post', 'wcf2w_meta_box_data_save');
function wcf2w_meta_box_data_save($post_id) {

    if (get_post_type($post_id) == 'wcf2w_contacts'){
        if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
            return;

        //getting
        if(isset($_POST['wcf2w_phone'])){ $wcf2w_phone = sanitize_text_field($_POST['wcf2w_phone']); } else { $wcf2w_phone = ''; }
        if(isset($_POST['wcf2w_title'])){ $wcf2w_title = sanitize_text_field($_POST['wcf2w_title']); } else { $wcf2w_title = ''; }
        if(isset($_POST['wcf2w_msg'])){ $wcf2w_msg = sanitize_text_field($_POST['wcf2w_msg']); } else { $wcf2w_msg = ''; }
        if(isset($_POST['wcf2w_add_to_product_page'])){ $wcf2w_add_to_product_page = sanitize_text_field($_POST['wcf2w_add_to_product_page']); } else { $wcf2w_add_to_product_page = ''; }
        if(isset($_POST['wcf2w_exclude_from_list'])){ $wcf2w_exclude_from_list = sanitize_text_field($_POST['wcf2w_exclude_from_list']); } else { $wcf2w_exclude_from_list = ''; }
		if(isset($_POST['wcf2w_monday'])){ $wcf2w_monday = sanitize_text_field($_POST['wcf2w_monday']); } else { $wcf2w_monday = ''; }
		if(isset($_POST['wcf2w_monday_from'])){ $wcf2w_monday_from = sanitize_text_field($_POST['wcf2w_monday_from']); } else { $wcf2w_monday_from = ''; }
		if(isset($_POST['wcf2w_monday_to'])){ $wcf2w_monday_to = sanitize_text_field($_POST['wcf2w_monday_to']); } else { $wcf2w_monday_to = ''; }
		if(isset($_POST['wcf2w_tuesday'])){ $wcf2w_tuesday = sanitize_text_field($_POST['wcf2w_tuesday']); } else { $wcf2w_tuesday = ''; }
		if(isset($_POST['wcf2w_tuesday_from'])){ $wcf2w_tuesday_from = sanitize_text_field($_POST['wcf2w_tuesday_from']); } else { $wcf2w_tuesday_from = ''; }
		if(isset($_POST['wcf2w_tuesday_to'])){ $wcf2w_tuesday_to = sanitize_text_field($_POST['wcf2w_tuesday_to']); } else { $wcf2w_tuesday_to = ''; }
		if(isset($_POST['wcf2w_wednesday'])){ $wcf2w_wednesday = sanitize_text_field($_POST['wcf2w_wednesday']); } else { $wcf2w_wednesday = ''; }
		if(isset($_POST['wcf2w_wednesday_from'])){ $wcf2w_wednesday_from = sanitize_text_field($_POST['wcf2w_wednesday_from']); } else { $wcf2w_wednesday_from = ''; }
		if(isset($_POST['wcf2w_wednesday_to'])){ $wcf2w_wednesday_to = sanitize_text_field($_POST['wcf2w_wednesday_to']); } else { $wcf2w_wednesday_to = ''; }
		if(isset($_POST['wcf2w_thursday'])){ $wcf2w_thursday = sanitize_text_field($_POST['wcf2w_thursday']); } else { $wcf2w_thursday = ''; }
		if(isset($_POST['wcf2w_thursday_from'])){ $wcf2w_thursday_from = sanitize_text_field($_POST['wcf2w_thursday_from']); } else { $wcf2w_thursday_from = ''; }
		if(isset($_POST['wcf2w_thursday_to'])){ $wcf2w_thursday_to = sanitize_text_field($_POST['wcf2w_thursday_to']); } else { $wcf2w_thursday_to = ''; }
		if(isset($_POST['wcf2w_friday'])){ $wcf2w_friday = sanitize_text_field($_POST['wcf2w_friday']); } else { $wcf2w_friday = ''; }
		if(isset($_POST['wcf2w_friday_from'])){ $wcf2w_friday_from = sanitize_text_field($_POST['wcf2w_friday_from']); } else { $wcf2w_friday_from = ''; }
		if(isset($_POST['wcf2w_friday_to'])){ $wcf2w_friday_to = sanitize_text_field($_POST['wcf2w_friday_to']); } else { $wcf2w_friday_to = ''; }
		if(isset($_POST['wcf2w_saturday'])){ $wcf2w_saturday = sanitize_text_field($_POST['wcf2w_saturday']); } else { $wcf2w_saturday = ''; }
		if(isset($_POST['wcf2w_saturday_from'])){ $wcf2w_saturday_from = sanitize_text_field($_POST['wcf2w_saturday_from']); } else { $wcf2w_saturday_from = ''; }
		if(isset($_POST['wcf2w_saturday_to'])){ $wcf2w_saturday_to = sanitize_text_field($_POST['wcf2w_saturday_to']); } else { $wcf2w_saturday_to = ''; }
		if(isset($_POST['wcf2w_sunday'])){ $wcf2w_sunday = sanitize_text_field($_POST['wcf2w_sunday']); } else { $wcf2w_sunday = ''; }
		if(isset($_POST['wcf2w_sunday_from'])){ $wcf2w_sunday_from = sanitize_text_field($_POST['wcf2w_sunday_from']); } else { $wcf2w_sunday_from = ''; }
		if(isset($_POST['wcf2w_sunday_to'])){ $wcf2w_sunday_to = sanitize_text_field($_POST['wcf2w_sunday_to']); } else { $wcf2w_sunday_to = ''; }
        
        //saving
        update_post_meta($post_id, 'wcf2w_phone', $wcf2w_phone);
        update_post_meta($post_id, 'wcf2w_title', $wcf2w_title);
       	update_post_meta($post_id, 'wcf2w_msg', $wcf2w_msg);
       	update_post_meta($post_id, 'wcf2w_add_to_product_page', $wcf2w_add_to_product_page);
       	update_post_meta($post_id, 'wcf2w_exclude_from_list', $wcf2w_exclude_from_list);
		update_post_meta($post_id, 'wcf2w_monday', $wcf2w_monday);
		update_post_meta($post_id, 'wcf2w_monday_from', $wcf2w_monday_from);
		update_post_meta($post_id, 'wcf2w_monday_to', $wcf2w_monday_to);
		update_post_meta($post_id, 'wcf2w_tuesday', $wcf2w_tuesday);
		update_post_meta($post_id, 'wcf2w_tuesday_from', $wcf2w_tuesday_from);
		update_post_meta($post_id, 'wcf2w_tuesday_to', $wcf2w_tuesday_to);
		update_post_meta($post_id, 'wcf2w_wednesday', $wcf2w_wednesday);
		update_post_meta($post_id, 'wcf2w_wednesday_from', $wcf2w_wednesday_from);
		update_post_meta($post_id, 'wcf2w_wednesday_to', $wcf2w_wednesday_to);
		update_post_meta($post_id, 'wcf2w_thursday', $wcf2w_thursday);
		update_post_meta($post_id, 'wcf2w_thursday_from', $wcf2w_thursday_from);
		update_post_meta($post_id, 'wcf2w_thursday_to', $wcf2w_thursday_to);
		update_post_meta($post_id, 'wcf2w_friday', $wcf2w_friday);
		update_post_meta($post_id, 'wcf2w_friday_from', $wcf2w_friday_from);
		update_post_meta($post_id, 'wcf2w_friday_to', $wcf2w_friday_to);
		update_post_meta($post_id, 'wcf2w_saturday', $wcf2w_saturday);
		update_post_meta($post_id, 'wcf2w_saturday_from', $wcf2w_saturday_from);
		update_post_meta($post_id, 'wcf2w_saturday_to', $wcf2w_saturday_to);
		update_post_meta($post_id, 'wcf2w_sunday', $wcf2w_sunday);
		update_post_meta($post_id, 'wcf2w_sunday_from', $wcf2w_sunday_from);
		update_post_meta($post_id, 'wcf2w_sunday_to', $wcf2w_sunday_to);

        //clear cache
        if(class_exists('comet_cache')) comet_cache::clear();
        if(class_exists('autoptimizeCache')) autoptimizeCache::clearall();
        if(function_exists ('wp_cache_clear_cache')) wp_cache_clear_cache();
    }
}

//redirect
function wcf2w_post_type_redirect($template){
	$post_type = get_post_type(get_the_ID());
	
	if($post_type == 'wcf2w_contacts'){
		wp_redirect('/404/');
		exit;
	}

	
	return $template;
}
add_filter('template_include', 'wcf2w_post_type_redirect', 99);
?>