<?php
/*widget*/

function wcf2w_widgets_init() {   
    register_sidebar( array(
        'name'          => esc_html__( 'WhatsApp Contact Button Area', 'wcf2w' ),
        'id'            => 'wcf2w_widget',
        'description'   => esc_html__( 'Add widgets here.', 'wcf2w' ),
        'before_title'  => '',
        'after_title'   => '',
        'before_widget' => '',
        'after_widget'  => '',
    ) );
}
add_action( 'widgets_init', 'wcf2w_widgets_init' );

class wcf2w_button_widget extends WP_Widget {
    function __construct() {
        parent::__construct(
            'wcf2w_button_widget', 
            'WhatsApp Contact Button Widget',
            array('description' => 'Displays WhatsApp contact button on your site')
        );
    }

    function widget( $args, $instance ) {
        $wcf2w_btn_text = apply_filters('widget_text', $instance['wcf2w_btn_text']);
        $wcf2w_phone = apply_filters('widget_text', $instance['wcf2w_phone']);
        $wcf2w_msg = apply_filters('widget_text', $instance['wcf2w_msg']);
        $wcf2w_btn_bg_spcolor = apply_filters('widget_text', $instance['wcf2w_btn_bg_spcolor']);
        $wcf2w_btn_text_spcolor = apply_filters('widget_text', $instance['wcf2w_btn_text_spcolor']);
        $wcf2w_btn_style = apply_filters('widget_text', $instance['wcf2w_btn_style']);
        $wcf2w_btn_position = apply_filters('widget_text', $instance['wcf2w_btn_position']);
        $wcf2w_btn_animation = apply_filters('widget_text', $instance['wcf2w_btn_animation']);
        $wcf2w_btn_position_left = apply_filters('widget_text', $instance['wcf2w_btn_position_left']);
        $wcf2w_btn_position_right = apply_filters('widget_text', $instance['wcf2w_btn_position_right']);
        $wcf2w_btn_position_bottom = apply_filters('widget_text', $instance['wcf2w_btn_position_bottom']);
        $wcf2w_btn_only_mobile = apply_filters('widget_text', $instance['wcf2w_btn_only_mobile']);
        $wcf2w_show_modal = apply_filters('widget_text', $instance['wcf2w_show_modal']);

        /*classes*/

        //animation
        $animation_class = wcf2w_get_animation_class($wcf2w_btn_animation);

        //style
        if($wcf2w_btn_style =='rectangular button') $wcf2w_btn_style_class = 'wcf2w_rectangular_button'; 
        if($wcf2w_btn_style =='round button') $wcf2w_btn_style_class = 'wcf2w_round_button';
   
        //check mobile device    
        $is_wcf2w_mobile_device = wcf2w_check_mobile_device(); 

        /*position*/   

        if($wcf2w_btn_position == 'right') $wcf2w_sp_position = 'right:'.$wcf2w_btn_position_right.'px; bottom:'.$wcf2w_btn_position_bottom .'px';

        if($wcf2w_btn_position == 'left') $wcf2w_sp_position = 'left:'.$wcf2w_btn_position_left.'px; bottom:'.$wcf2w_btn_position_bottom .'px';

    
        /*button text*/    

        if($wcf2w_btn_style =='round button') $wcf2w_btn_text = '';
        
        echo $args['before_widget'];


		if($is_wcf2w_mobile_device){
            //mobile
            if($wcf2w_show_modal == 'y'){
                echo '<span data-modal-link="#wcf2w_open" class="'.$wcf2w_btn_style_class.' '.$animation_class.'" style="background-color: '.$wcf2w_btn_bg_spcolor.'; color: '.$wcf2w_btn_text_spcolor.'; '.$wcf2w_sp_position.'"><i class="socicon-whatsapp"></i> '.$wcf2w_btn_text.'</span>';

            } else {
                echo '<span data-phone="'.$wcf2w_phone.'" data-msg="'.$wcf2w_msg.'" class="'.$wcf2w_btn_style_class.' '.$animation_class.' wcf2w_btn" style="background-color: '.$wcf2w_btn_bg_spcolor.'; color: '.$wcf2w_btn_text_spcolor.'; '.$wcf2w_sp_position.'"><i class="socicon-whatsapp"></i> '.$wcf2w_btn_text.'</span>';
            }    
		          
		} else {
			//pc
			if($wcf2w_btn_only_mobile == 'n'){
                if($wcf2w_show_modal == 'y'){
                    echo '<span data-modal-link="#wcf2w_open" class="'.$wcf2w_btn_style_class.' '.$animation_class.'" style="background-color: '.$wcf2w_btn_bg_spcolor.'; color: '.$wcf2w_btn_text_spcolor.'; '.$wcf2w_sp_position.'"><i class="socicon-whatsapp"></i> '.$wcf2w_btn_text.'</span>';

                } else {
                    echo '<span data-phone="'.$wcf2w_phone.'" data-msg="'.$wcf2w_msg.'" class="'.$wcf2w_btn_style_class.' '.$animation_class.' wcf2w_btn" style="background-color: '.$wcf2w_btn_bg_spcolor.'; color: '.$wcf2w_btn_text_spcolor.'; '.$wcf2w_sp_position.'"><i class="socicon-whatsapp"></i> '.$wcf2w_btn_text.'</span>';
                }      
			}
		}

        echo $args['after_widget'];
    }

    function form( $instance ) {
        $wcf2w_btn_text = @ $instance['wcf2w_btn_text'] ?: __('Contact us','wcf2w');
        $wcf2w_phone = @ $instance['wcf2w_phone'] ?: '';
        $wcf2w_msg = @ $instance['wcf2w_msg'] ?: __('I have a question','wcf2w');
        $wcf2w_btn_bg_spcolor = @ $instance['wcf2w_btn_bg_spcolor'] ?: '#2ECC71';
        $wcf2w_btn_text_spcolor = @ $instance['wcf2w_btn_text_spcolor'] ?: '#ffffff';
        $wcf2w_btn_style = @ $instance['wcf2w_btn_style'] ?: 'rectangular button';
        $wcf2w_btn_position = @ $instance['wcf2w_btn_position'] ?: 'left';
        $wcf2w_btn_animation = @ $instance['wcf2w_btn_animation'] ?: 'tada';
        $wcf2w_btn_position_left = @ $instance['wcf2w_btn_position_left'] ?: '20';
        $wcf2w_btn_position_right = @ $instance['wcf2w_btn_position_right'] ?: '20';
        $wcf2w_btn_position_bottom = @ $instance['wcf2w_btn_position_bottom'] ?: '20';	
        $wcf2w_btn_only_mobile = @ $instance['wcf2w_btn_only_mobile'] ?: 'n';
        $wcf2w_show_modal = @ $instance['wcf2w_show_modal'] ?: 'n';

        ?>
        <p><label for="<?php echo $this->get_field_id('wcf2w_btn_text'); ?>"><?php echo __('Text', 'wcf2w'); ?>:</label></br>
        <input type="text" id="<?php echo $this->get_field_id('wcf2w_btn_text'); ?>" name="<?php echo $this->get_field_name('wcf2w_btn_text'); ?>" value="<?php echo esc_attr($wcf2w_btn_text); ?>"></p> 

        <p><label for="<?php echo $this->get_field_id('wcf2w_phone'); ?>"><?php echo __('Phone', 'wcf2w'); ?>:</label></br>
        <input type="text" id="<?php echo $this->get_field_id('wcf2w_phone'); ?>" name="<?php echo $this->get_field_name('wcf2w_phone'); ?>" value="<?php echo esc_attr($wcf2w_phone); ?>"></br>
        <i><?php echo __('Use mobile phone number without "+" character. Example: 79094459070.', 'wcf2w'); ?></i></p> 

        <p><label for="<?php echo $this->get_field_id('wcf2w_msg'); ?>"><?php echo __('Message', 'wcf2w'); ?>:</label></br>
        <input type="text" id="<?php echo $this->get_field_id('wcf2w_msg'); ?>" name="<?php echo $this->get_field_name('wcf2w_msg'); ?>" value="<?php echo esc_attr($wcf2w_msg); ?>"></p> 

        <p><label for="<?php echo $this->get_field_id('wcf2w_btn_bg_spcolor'); ?>"><?php echo __('Button Color', 'wcf2w'); ?>:</label></br>
        <input type="text" class="spcolor wcf2w_btn_bg_spcolor" id="<?php echo $this->get_field_id('wcf2w_btn_bg_spcolor'); ?>" name="<?php echo $this->get_field_name('wcf2w_btn_bg_spcolor'); ?>" value="<?php echo $wcf2w_btn_bg_spcolor ?>">
        </p>
        <p><label for="<?php echo $this->get_field_id('wcf2w_btn_text_spcolor'); ?>"><?php echo __('Text color', 'wcf2w'); ?>:</label></br>
        <input type="text" class="spcolor" id="<?php echo $this->get_field_id('wcf2w_btn_text_spcolor'); ?>" name="<?php echo $this->get_field_name('wcf2w_btn_text_spcolor'); ?>" value="<?php echo $wcf2w_btn_text_spcolor ?>">
    	</p>
        <p>
            <label for="<?php echo $this->get_field_id('wcf2w_btn_style'); ?>"><?php echo __('Style', 'wcf2w'); ?>:</label></br>
            <select class="widefat" id="<?php echo $this->get_field_id('wcf2w_btn_style'); ?>" name="<?php echo $this->get_field_name('wcf2w_btn_style'); ?>">
                <option value="<?php echo $wcf2w_btn_style;?>" selected><?php echo $wcf2w_btn_style;?></option>
                <option disabled>-------</option>
                <option value="rectangular button">rectangular button</option>
                <option value="round button">round button</option>
            </select>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('wcf2w_btn_animation'); ?>"><?php echo __('Button animation', 'wcf2w'); ?>:</label> 
            <select class="widefat" id="<?php echo $this->get_field_id('wcf2w_btn_animation'); ?>" name="<?php echo $this->get_field_name('wcf2w_btn_animation'); ?>">
                <option value="<?php echo $wcf2w_btn_animation;?>"><?php echo $wcf2w_btn_animation;?></option>
                <option disabled>---</option>
                <option value="none"><?php echo __('none', 'wcf2w'); ?></option>
                <option value="rotate"><?php echo __('rotate', 'wcf2w'); ?></option>
                <option value="tada"><?php echo __('tada', 'wcf2w'); ?></option>
                <option value="swing"><?php echo __('swing', 'wcf2w'); ?></option>
                <option value="grow"><?php echo __('grow', 'wcf2w'); ?></option>
                <option value="shrink"><?php echo __('shrink', 'wcf2w'); ?></option>
                <option value="buzz"><?php echo __('buzz', 'wcf2w'); ?></option>
                <option value="forward"><?php echo __('forward', 'wcf2w'); ?></option>
                <option value="backward"><?php echo __('backward', 'wcf2w'); ?></option>
            </select>
        </p>
		<p>
			<label for="<?php echo $this->get_field_id('wcf2w_btn_position'); ?>"><?php echo __('Button position', 'wcf2w'); ?>:</label> 
			<select class="widefat" id="<?php echo $this->get_field_id('wcf2w_btn_position'); ?>" name="<?php echo $this->get_field_name('wcf2w_btn_position'); ?>">
				<option value="<?php echo $wcf2w_btn_position;?>"><?php if($wcf2w_btn_position=='left'){ echo __('left', 'wcf2w');} else {echo __('right', 'wcf2w');}?></option>
				<option disabled>---</option>
                <option value="left"><?php echo __('left', 'wcf2w'); ?></option>
                <option value="right"><?php echo __('right', 'wcf2w'); ?></option>
			</select>
		</p>
        <p><?php echo __('Custom position:', 'wcf2w'); ?></br>

		<label for="<?php echo $this->get_field_id('wcf2w_btn_position_left'); ?>"><?php echo __('left', 'wcf2w'); ?>:</label></br>
        <input type="number" class="wcf2w_btn_position_left" id="<?php echo $this->get_field_id('wcf2w_btn_position_left'); ?>" name="<?php echo $this->get_field_name('wcf2w_btn_position_left'); ?>" value="<?php echo $wcf2w_btn_position_left ?>"> px
    	</p>
    	<p><label for="<?php echo $this->get_field_id('wcf2w_btn_position_right'); ?>"><?php echo __('right', 'wcf2w'); ?>:</label></br>
        <input type="number" class="wcf2w_btn_position_right" id="<?php echo $this->get_field_id('wcf2w_btn_position_right'); ?>" name="<?php echo $this->get_field_name('wcf2w_btn_position_right'); ?>" value="<?php echo $wcf2w_btn_position_right ?>"> px
    	</p>
    	<p><label for="<?php echo $this->get_field_id('wcf2w_btn_position_bottom'); ?>"><?php echo __('bottom', 'wcf2w'); ?>:</label></br>
        <input type="number" id="<?php echo $this->get_field_id('wcf2w_btn_position_bottom'); ?>" name="<?php echo $this->get_field_name('wcf2w_btn_position_bottom'); ?>" value="<?php echo $wcf2w_btn_position_bottom ?>"> px
    	</p>
        <p><label for="<?php echo $this->get_field_id('wcf2w_btn_only_mobile'); ?>"><?php echo __('Show button only on mobile devices', 'wcf2w'); ?>:</label></br>

        <?php
        $check_y = '';
        $check_n = '';
        if($wcf2w_btn_only_mobile == 'y') $check_y = 'checked';
        else $check_n = 'checked';
        ?>

        <input type="radio" id="<?php echo $this->get_field_id('wcf2w_btn_only_mobile'); ?>" name="<?php echo $this->get_field_name('wcf2w_btn_only_mobile'); ?>" value="y" <?php echo $check_y;?>><?php echo __('yes', 'wcf2w');?>
        <input type="radio" id="<?php echo $this->get_field_id('wcf2w_btn_only_mobile'); ?>" name="<?php echo $this->get_field_name('wcf2w_btn_only_mobile'); ?>" value="n" <?php echo $check_n;?>><?php echo __('no', 'wcf2w');?></br></p>


        <p><label for="<?php echo $this->get_field_id('wcf2w_show_modal'); ?>"><?php echo __('Show modal by click', 'wcf2w'); ?>:</label></br>

        <?php
        $check_y = '';
        $check_n = '';
        if($wcf2w_show_modal == 'y') $check_y = 'checked';
        else $check_n = 'checked';
        ?>

        <input type="radio" id="<?php echo $this->get_field_id('wcf2w_show_modal'); ?>" name="<?php echo $this->get_field_name('wcf2w_show_modal'); ?>" value="y" <?php echo $check_y;?>><?php echo __('yes', 'wcf2w');?>
        <input type="radio" id="<?php echo $this->get_field_id('wcf2w_show_modal'); ?>" name="<?php echo $this->get_field_name('wcf2w_show_modal'); ?>" value="n" <?php echo $check_n;?>><?php echo __('no', 'wcf2w');?></br></p>

        <?php 
    }

    function update($new_instance, $old_instance) {
        $instance = array();
        $instance['wcf2w_btn_text'] = ( ! empty( $new_instance['wcf2w_btn_text'] ) ) ? $new_instance['wcf2w_btn_text'] : '';
        $instance['wcf2w_phone'] = ( ! empty( $new_instance['wcf2w_phone'] ) ) ? $new_instance['wcf2w_phone'] : '';
        $instance['wcf2w_msg'] = ( ! empty( $new_instance['wcf2w_msg'] ) ) ? $new_instance['wcf2w_msg'] : '';
        $instance['wcf2w_btn_bg_spcolor'] = ( ! empty( $new_instance['wcf2w_btn_bg_spcolor'] ) ) ? $new_instance['wcf2w_btn_bg_spcolor'] : '';
        $instance['wcf2w_btn_text_spcolor'] = ( ! empty( $new_instance['wcf2w_btn_text_spcolor'] ) ) ? $new_instance['wcf2w_btn_text_spcolor'] : '';
        $instance['wcf2w_btn_style'] = ( ! empty( $new_instance['wcf2w_btn_style'] ) ) ? $new_instance['wcf2w_btn_style'] : '';
        $instance['wcf2w_btn_position'] = ( ! empty( $new_instance['wcf2w_btn_position'] ) ) ? $new_instance['wcf2w_btn_position'] : '';
        $instance['wcf2w_btn_animation'] = ( ! empty( $new_instance['wcf2w_btn_animation'] ) ) ? $new_instance['wcf2w_btn_animation'] : '';
        $instance['wcf2w_btn_position_left'] = ( ! empty( $new_instance['wcf2w_btn_position_left'] ) ) ? $new_instance['wcf2w_btn_position_left'] : '';
        $instance['wcf2w_btn_position_right'] = ( ! empty( $new_instance['wcf2w_btn_position_right'] ) ) ? $new_instance['wcf2w_btn_position_right'] : '';
        $instance['wcf2w_btn_position_bottom'] = ( ! empty( $new_instance['wcf2w_btn_position_bottom'] ) ) ? $new_instance['wcf2w_btn_position_bottom'] : '';
        $instance['wcf2w_btn_only_mobile'] = ( ! empty( $new_instance['wcf2w_btn_only_mobile'] ) ) ? $new_instance['wcf2w_btn_only_mobile'] : '';
        $instance['wcf2w_show_modal'] = ( ! empty( $new_instance['wcf2w_show_modal'] ) ) ? $new_instance['wcf2w_show_modal'] : '';        
        return $instance;
    }

}

function register_wcf2w_button_widget() {
    register_widget('wcf2w_button_widget');
}

add_action('widgets_init', 'register_wcf2w_button_widget');

function wcf2w_widget_area(){
    echo '<div class="wcf2w_widget_area">';
    dynamic_sidebar('wcf2w_widget');
    echo '</div>';
}

add_action('wp_footer', 'wcf2w_widget_area');